//! The network maestro manages starting, stopping, and interacting with the network being run by
//! docker-compose and generated by the network generator.

mod compose_adapter;

pub use compose_adapter::ComposeShellMaestro;

use std::path::PathBuf;

// TODO: Move into lower level crate both crates depend on.
/// A unique identifier of a running docker container which is part of the compose network.
pub struct ContainerInstanceId(pub usize);

pub type Result<T, E = Error> = std::result::Result<T, E>;

#[async_trait::async_trait]
pub trait NetworkMaestro {
    /// Start the whole network, including all default entities/services
    async fn start_network(&self) -> Result<()>;
    /// Stop the whole network, including all default entities/services
    async fn stop_network(&self) -> Result<()>;

    /// Start an instance of a substrate node
    async fn start_node(&self, instance: ContainerInstanceId) -> Result<()>;
    /// Stop an instance of a substrate node
    async fn stop_node(&self, instance: ContainerInstanceId) -> Result<()>;

    /// Start an instance of a member-api service
    async fn start_member(&self, instance: ContainerInstanceId) -> Result<()>;
    /// Stop an instance of a member-api service
    async fn stop_member(&self, instance: ContainerInstanceId) -> Result<()>;

    /// Start the trust instance
    async fn start_trust(&self) -> Result<()>;
    /// Stop the trust instance
    async fn stop_trust(&self) -> Result<()>;

    /// Start the trust non-consensus node instance
    async fn start_trust_node(&self) -> Result<()>;
    /// Stop the trust non-consensus node instance
    async fn stop_trust_node(&self) -> Result<()>;

    /// Start the mock banks instance
    async fn start_bank_mock(&self) -> Result<()>;
    /// Stop the mock banks instance
    async fn stop_bank_mock(&self) -> Result<()>;
}

#[derive(thiserror::Error, Debug)]
pub enum Error {
    #[error("Underlying I/O error")]
    IoError(#[from] std::io::Error),
    #[error("Bad path: {0}")]
    BadPath(PathBuf),
}
